﻿Imports ENTIDADES
Imports System.Data.SqlClient
Imports Dapper

Public Class DAODocumento
    Public Function Insertar(eDocumento As Documentos) As Boolean
        Dim Result As Boolean = False
        Try
            Dim Sql As String
            Using Conn As New SqlConnection(Conexion.ConnectionString)
                Conn.Open()
                Dim param As New DynamicParameters()
                param.Add("@IdPerso", eDocumento.IdPerso, dbType:=DbType.Int32)
                param.Add("@Fecha", eDocumento.Fecha, dbType:=DbType.Date)
                param.Add("@Documento", eDocumento.Documento, dbType:=DbType.String)
                '          Sql = "INSERT INTO Documentos VALUES(@IdPerso,@Fecha,@Documento)"
                Sql = "INSERT INTO Documentos VALUES(@Fecha,@IdPerso,@Documento)"
                Dim OkPago = Conn.Execute(Sql, param, commandType:=CommandType.Text)
                If OkPago = 0 Then
                    Throw New Exception("Error al insertar Documentos")
                End If
                Result = True
            End Using
        Catch ex As Exception
            Throw New Exception(ex.Message)
        End Try
        Return Result
    End Function

    Public Function Update(DocumentoEditar As Documentos) As Boolean
        Dim Result As Boolean = False
        Try
            Dim Sql As String
            Using Conn As New SqlConnection(Conexion.ConnectionString)
                Conn.Open()
                Dim param As New DynamicParameters()
                param.Add("@IdPerso", DocumentoEditar.IdPerso, dbType:=DbType.Int32)
                param.Add("@Fecha", DocumentoEditar.Fecha, dbType:=DbType.Date)
                param.Add("@Documento", DocumentoEditar.Documento, dbType:=DbType.String)
                param.Add("@Id", DocumentoEditar.IdDocu, dbType:=DbType.Int32)
                Sql = "UPDATE Documentos SET IdPerso=@IdPerso,Fecha=@Fecha,Documento=@Documento Where IdDocu=@ID"
                Dim Ok = Conn.Execute(Sql, param, commandType:=CommandType.Text)
                If Ok = 0 Then
                    Throw New Exception("Error al modificar Documentos")
                Else
                    Result = True
                End If
            End Using
        Catch ex As Exception
            Throw New Exception(ex.Message)
        End Try
        Return Result
    End Function

    Public Function Delete(ID As Int32) As Boolean
        Dim Result As Boolean = False
        Try
            Using Conn As New SqlConnection(Conexion.ConnectionString)
                Conn.Open()
                Dim sql = String.Empty
                Dim param As New DynamicParameters()
                param.Add("@Id", ID, dbType:=DbType.Int32)
                sql = "DELETE From Documentos Where IdDocu=@ID"
                Dim Ok = Conn.Execute(sql, param, commandType:=CommandType.Text)
                If Ok = 0 Then
                    Throw New Exception("Error al eliminar un Documento")
                Else
                    Result = True
                End If
            End Using
        Catch ex As Exception
            Throw New Exception(ex.Message)
        End Try
        Return Result
    End Function

    Public Function GetAll() As List(Of Documentos)
        Dim Result As List(Of Documentos) = Nothing
        Using Conn As New SqlConnection(Conexion.ConnectionString)
            Try
                Conn.Open()
                Result = Conn.Query(Of Documentos)("Select * From Documentos Order By Documento").AsList
            Catch ex As Exception
                Throw New Exception(ex.Message)
            End Try
        End Using
        Return Result
    End Function

    Public Function GetByID(ID As Int32) As Documentos
        Dim Result As Documentos = Nothing
        Using Conn As New SqlConnection(Conexion.ConnectionString)
            Try
                Conn.Open()
                Dim sql = String.Empty
                sql = "Select * From Documentos Where IdDocu=@ID"
                Result = Conn.QueryFirstOrDefault(Of Documentos)(sql, New With {ID})
            Catch ex As Exception
                Throw New Exception(ex.Message)
            End Try
        End Using
        Return Result
    End Function

    Public Function GetByIdPerso(ID As Int32) As Documentos
        Dim Result As Documentos = Nothing
        Using Conn As New SqlConnection(Conexion.ConnectionString)
            Try
                Conn.Open()
                Dim sql = String.Empty
                sql = "Select * From Documentos Where IdPerso=@ID"
                Result = Conn.QueryFirstOrDefault(Of Documentos)(sql, New With {ID})
            Catch ex As Exception
                Throw New Exception(ex.Message)
            End Try
        End Using
        Return Result
    End Function

    Public Function GetByDocumento(name As String) As List(Of Documentos)
        Dim Result As List(Of Documentos) = Nothing
        Using Conn As New SqlConnection(Conexion.ConnectionString)
            Try
                Conn.Open()
                Dim sql = String.Empty
                sql = "Select * From Documentos Where Documento Like '%' + @name + '%'"
                Result = Conn.Query(Of Documentos)(sql, New With {name}).AsList()
            Catch ex As Exception
                Throw New Exception(ex.Message)
            End Try
        End Using
        Return Result
    End Function

    Public Function GetByCp(name As String) As List(Of Documentos)
        Dim Result As List(Of Documentos) = Nothing
        Using Conn As New SqlConnection(Conexion.ConnectionString)
            Try
                Conn.Open()
                Dim sql = String.Empty
                sql = "Select * From Documentos Where Documento Like @name + '%'"
                Result = Conn.Query(Of Documentos)(sql, New With {name}).AsList()
            Catch ex As Exception
                Throw New Exception(ex.Message)
            End Try
        End Using
        Return Result
    End Function

    Public Function GetCuentaReg() As Int32
        Dim Result As Int32 = 0
        Using Conn As New SqlConnection(Conexion.ConnectionString)
            Try
                Conn.Open()
                Dim sql = String.Empty
                sql = "Select Count(IdDocu) as Contador From Documentos"
                Result = Conn.ExecuteScalar(Of Short)(sql)
            Catch ex As Exception
                Throw New Exception(ex.Message)
            End Try
        End Using
        Return Result
    End Function
End Class
