﻿'******************* Capa de acceso a datos *******************
Imports System.Data.SqlClient
Imports ENTIDADES
Imports Dapper

Public Class DAOPersona
    Public Function Insertar(ePersona As Personas) As Boolean
        Dim Result As Boolean = False
        Try
            Using Conn As New SqlConnection(Conexion.ConnectionString)
                Conn.Open()
                Dim param As New DynamicParameters()
                param.Add("@Nombre", ePersona.Nombre, dbType:=DbType.String)
                Dim Sql As String = "INSERT INTO Personas Values (@nombre)"
                Dim OkPago = Conn.Execute(Sql, param, commandType:=CommandType.Text)
                If OkPago = 0 Then
                    Throw New Exception("Error al insertar Personas")
                End If
                Result = True
            End Using
        Catch ex As Exception
            Throw New Exception(ex.Message)
        End Try
        Return Result
    End Function

    Public Function Update(PersonaAEditar As Personas) As Boolean
        Dim Result As Boolean = False
        Try
            Dim Sql As String
            Using Conn As New SqlConnection(Conexion.ConnectionString)
                Conn.Open()
                Dim param As New DynamicParameters()
                param.Add("@Nombre", PersonaAEditar.Nombre, dbType:=DbType.String)
                param.Add("@Id", PersonaAEditar.IdPerso, dbType:=DbType.Int32)
                Sql = "UPDATE PersonaS SET Nombre=@Nombre Where IdPerso=@ID"
                Dim Ok = Conn.Execute(Sql, param, commandType:=CommandType.Text)
                If Ok = 0 Then
                    Throw New Exception("Error al modificar Personas")
                Else
                    Result = True
                End If
            End Using
        Catch ex As Exception
            Throw New Exception(ex.Message)
        End Try
        Return Result
    End Function

    Public Function Delete(ID As Int32) As Boolean
        Dim Result As Boolean = False
        Try
            Using Conn As New SqlConnection(Conexion.ConnectionString)
                Conn.Open()
                Dim sql = String.Empty
                Dim param As New DynamicParameters()
                param.Add("@Id", ID, dbType:=DbType.Int32)
                sql = "DELETE From Personas Where IdPerso=@ID"
                Dim Ok = Conn.Execute(sql, param, commandType:=CommandType.Text)
                If Ok = 0 Then
                    Throw New Exception("Error al eliminar una Persona")
                Else
                    Result = True
                End If
            End Using
        Catch ex As Exception
            Throw New Exception(ex.Message)
        End Try
        Return Result
    End Function

    Public Function GetAll() As List(Of Personas)
        Dim Result As List(Of Personas) = Nothing
        Using Conn As New SqlConnection(Conexion.ConnectionString)
            Try
                Conn.Open()
                Result = Conn.Query(Of Personas)("Select * From Personas Order By Nombre").AsList
            Catch ex As Exception
                Throw New Exception(ex.Message)
            End Try
        End Using
        Return Result
    End Function

    Public Function GetByID(ID As Int32) As Personas
        Dim Result As Personas = Nothing
        Using Conn As New SqlConnection(Conexion.ConnectionString)
            Try
                Conn.Open()
                Dim sql = String.Empty
                sql = "Select * From Personas Where IdPerso=@ID"
                Result = Conn.QueryFirstOrDefault(Of Personas)(sql, New With {ID})
            Catch ex As Exception
                Throw New Exception(ex.Message)
            End Try
        End Using
        Return Result
    End Function

    Public Function GetByName(name As String) As List(Of Personas)
        Dim Result As List(Of Personas) = Nothing
        Using Conn As New SqlConnection(Conexion.ConnectionString)
            Try
                Conn.Open()
                Dim sql = String.Empty
                sql = "Select * From Personas Where Nombre Like @name + '%'"
                Result = Conn.Query(Of Personas)(sql, New With {name}).AsList()
            Catch ex As Exception
                Throw New Exception(ex.Message)
            End Try
        End Using
        Return Result
    End Function
End Class
