﻿'******************* Capa de presentación del cliente *******************
'Importando la Capa de Entidades y la Capa Logica que son necesarias para trabajar con las imagenes
Imports ENTIDADES
Imports BLL


Public Class frmPersonas
    'declaracion Declare delegados y eventos()
    Public Delegate Sub TraerPersona(ByVal ePersona As Personas)
    Public Event EnviarPersona As TraerPersona

    '**************  DECLARACION DE VARIABLES GLOBALES ****************'
    Private objPersona As New PersonasBL
    Private ePersona As New Personas
    Private sw As Integer
    Private Sql As String

    Private pPersona As String

    Public Sub Botones(ByVal x As Boolean)
        btnAñadir.Enabled = Not x
        btnModificar.Enabled = Not x
        btnEliminar.Enabled = Not x
        btnGrabar.Enabled = x
        Panel2.Enabled = x
    End Sub

    '***************************** Limpiar los TextBox ******************************'
    Public Sub Limpiar(ByVal Grupo As System.Windows.Forms.Panel)
        Dim miControl As Object
        Try
            For Each miControl In Grupo.Controls
                If miControl.GetType Is GetType(TextBox) Then
                    miControl.Clear()
                End If
                System.Windows.Forms.Application.DoEvents()
            Next
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    Public Sub New()
        MyBase.New
        InitializeComponent()
    End Sub

    Public Sub New(mPersona As String)
        InitializeComponent()
        Me.pPersona = mPersona
    End Sub

    '**********  EL EVENTO LOAD DEL FORMULARIO**********************'
    Private Sub FrmPersona_Load(ByVal sender As System.Object, ByVal e As EventArgs) Handles MyBase.Load
        Botones(False)
        Try
            Call ListarPersonas()
            If Not String.IsNullOrEmpty(pPersona) Then
                txtfiltro.Text = Me.pPersona
            End If
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Advertencia", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    '*************************** Presentar los datos en el DataGridView y en los TextBox *************+'
    Private Sub ListarPersonas()
        Try
            LimpiaDgv()
            Limpiar(Panel2)
            cambioColor()
            PersonasBindingSource.DataSource = objPersona.GetAll()
            If PersonasBindingSource.Count = 0 Then
                MessageBox.Show("No existen Personas, proceda por Añadir", "Advertencia", MessageBoxButtons.OK, MessageBoxIcon.Information)
                btnAñadir.Focus()
            Else
                Dgv.DataSource = PersonasBindingSource
                Dim ePersona As Personas = TryCast(PersonasBindingSource.Current, Personas)
                MuestraDatos(ePersona)
            End If
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Advertencia", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    Sub cambioColor()
        ' desactivar los estilos visuales del sistema
        Me.Dgv.EnableHeadersVisualStyles = False
        ' estilo para las cabeceras
        Dim styCabeceras As DataGridViewCellStyle = New DataGridViewCellStyle()
        styCabeceras.BackColor = Color.LightYellow
        ' styCabeceras.ForeColor = Color.MediumAquamarine
        styCabeceras.ForeColor = Color.MediumBlue
        styCabeceras.Font = New Font("Comic Sans MS", 10, FontStyle.Italic) 'Or FontStyle.Bold)
        ' asignar estilo al grid
        Me.Dgv.ColumnHeadersDefaultCellStyle = styCabeceras
    End Sub

    Private Sub MuestraDatos(vPersona As Personas)
        txtIdPerso.Text = vPersona.IdPerso.ToString()
        txtNombre.Text = vPersona.Nombre
    End Sub

    '****************************** Botones de gestión -----------------------------

    '**********  EL EVENTO CLICK DEL BOTON AÑADIR********************'
    Private Sub BtnAñadir_Click(ByVal sender As System.Object, ByVal e As EventArgs) Handles btnAñadir.Click
        sw = 1
        LabelInfo.Text = ""
        Limpiar(Panel2)
        Botones(True)
        txtNombre.Focus()
    End Sub

    '**********  EL EVENTO CLICK DEL BOTON MODIFICAR****************'
    Private Sub BtnModificar_Click(ByVal sender As System.Object, ByVal e As EventArgs) Handles btnModificar.Click
        sw = 2
        Botones(True)
        LabelInfo.Text = ""
        txtNombre.Focus()
    End Sub

    '**********  EL EVENTO CLICK DEL BOTON ELIMINAR****************'
    Private Sub BtnEliminar_Click(ByVal sender As System.Object, ByVal e As EventArgs) Handles btnEliminar.Click
        sw = 3
        Botones(True)
        LabelInfo.Text = ""
    End Sub

    '**********  EL EVENTO CLICK DEL BOTON SALIR********************'
    Private Sub btnSalir_Click(sender As Object, e As EventArgs) Handles btnSalir.Click
        Try
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Information, ToString)
        Finally
            Close()
        End Try
    End Sub

    '**********  EL EVENTO CLICK DEL BOTON GRABAR***************'
    Private Sub BtnGrabar_Click(sender As Object, e As EventArgs) Handles btnGrabar.Click
        Try
            LabelInfo.Text = ""
            Select Case sw
                Case 1
                    Dim ePerso As New Personas With {
                            .Nombre = RTrim(txtNombre.Text)
                        }
                    If objPersona.Insertar(ePerso) Then
                        LabelInfo.Text = "Registro insertado correctamente"
                    End If
                Case 2
                    Dim PersonaEditar As New Personas With {
                            .IdPerso = Convert.ToInt16(txtIdPerso.Text),
                            .Nombre = txtNombre.Text
                        }
                    If objPersona.Update(PersonaEditar) = True Then
                        LabelInfo.Text = "Registro actualizado correctamente"
                    End If
                Case 3
                    If Dgv.CurrentRow.Selected Then
                        Dim vPersona As Personas = TryCast(PersonasBindingSource.Current, Personas)
                        If (MessageBox.Show("¿Seguro de eliminar este registro ?", "Confirme", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = DialogResult.Yes) Then
                            If objPersona.Delete(vPersona.IdPerso) = True Then
                                LabelInfo.Text = "Registro eliminado correctamente"
                            End If
                        End If
                    End If
            End Select
            If sw = 1 Then
                PersonasBindingSource.MoveLast()
            End If
            Call ListarPersonas()
        Catch ex As Exception
            Select Case Err.Number
                Case 5
                    MessageBox.Show("La Persona está cargada en Documentos, hay que eliminar primero el registro que la contiene", "Advertencia", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                Case Else
                    'MessageBox.Show(ex.Message, "Advertencia", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    LabelInfo.Text = ex.Message
            End Select
        Finally
            Botones(False)
        End Try
    End Sub

    '************************* Captura de datos por teclado **************************
    Private Sub TxtNombre_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtNombre.KeyPress
        Dim ch As Char = e.KeyChar
        If ch = Chr(9) Then
            btnGrabar.Focus()
        End If
    End Sub

    Private Sub TxtNombre_Validating(sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles txtNombre.Validating
        If Trim(txtNombre.Text) = "" Then
            MessageBox.Show("El nombre de la Persona es obligatorio")
            e.Cancel = True
        End If
        txtNombre.Text = StrConv(txtNombre.Text, VbStrConv.ProperCase)
    End Sub

    Private Sub LimpiaDgv()
        Try
            Dgv.DataSource = Nothing
        Catch ex As InvalidOperationException ' Esta excepcion es por si ocurriera
            MsgBox("Esta fila no se puede eliminar", MsgBoxStyle.Critical, "Operación inválida : : . . .")
        End Try
    End Sub

    '**********  EL EVENTO TEXCHANGED DEL TEXTFIELD txtBusqueda ********************'
    '************************ Busqueda por filtreado ***************************
    Private Sub CbBuscar_SelectedIndexChanged(sender As System.Object, e As System.EventArgs)
        Try
            txtfiltro.Text = ""
            txtfiltro.Focus()
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Information, ToString)
        End Try
    End Sub

    Private Sub TxtFiltro_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtfiltro.TextChanged
        If txtfiltro.Text = "" Then
            ListarPersonas()
        Else
            Filtra(txtfiltro.Text)
        End If
    End Sub

    Public Sub Filtra(ByVal texto As String)
        PersonasBindingSource.DataSource = objPersona.GetByPersona(texto)
        If PersonasBindingSource.Count = 0 Then
            MessageBox.Show("No existe esta Persona", "Advertencia", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        Else
            Dgv.DataSource = PersonasBindingSource
            Dim vPersona As Personas = TryCast(PersonasBindingSource.Current, Personas)
            txtIdPerso.Text = vPersona.IdPerso.ToString
            txtNombre.Text = vPersona.Nombre
        End If
    End Sub

    '**********  EL EVENTO CELLDOUBLECLICK DE LA GRILLA dgv para poner los datos en los TextBox********************'
    Private Sub Dgv_CellDoubleClick(sender As Object, e As DataGridViewCellEventArgs) Handles Dgv.CellDoubleClick
        Try
            ePersona = New Personas With {
            .IdPerso = Convert.ToInt16(Dgv.CurrentRow.Cells(0).Value),
            .Nombre = Dgv.CurrentRow.Cells(1).Value
            }
            RaiseEvent EnviarPersona(ePersona)
            Me.Close()
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Advertencia", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    '**********  EL EVENTO CELLCLICK DE LA GRILLA dgv para poner los datos en los TextBox********************'
    Private Sub Dgv_CellContentClick(sender As Object, e As DataGridViewCellEventArgs) Handles Dgv.CellContentClick
        If PersonasBindingSource.Count = 0 Then
            MessageBox.Show("No existe datos de Personas", "Advertencia", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        Else
            Dim vPersona As Personas = TryCast(PersonasBindingSource.Current, Personas)
            txtIdPerso.Text = Convert.ToString(vPersona.IdPerso)
            txtNombre.Text = vPersona.Nombre
        End If
    End Sub
End Class